/*
** ymca.h
**
** Made by mycroft (mycroft)
** <mycroft@minithins.net> on virgaria.minithins.net
**
** Started on  Sun Dec 22 19:09:51 2002 mycroft
** Last update Tue Jan 14 00:00:14 2003 mycroft
*/

#ifndef _YMCA_
#define _YMCA_

#define E_ERROR -1
#define E_TIMEOUT -2

/* #include <sys/time.h> */

typedef struct ymca_t
{
  struct ymca_t *next;
  int fd;
  void *ptr_data;
} *ymca;

ymca create_socket_list(void);

/* destroy socket list closes fd, but doesn t free data ptrs */
int destroy_socket_list(ymca *socket_liste);
int get_max_fd_value_from_socket_list(ymca socket_liste, int mode, int fd);
int is_fd_in_socket_list(ymca socket_liste, int fd);
ymca add_fd_to_socket_list(ymca *socket_liste, int fd);
ymca add_fd_data_to_socket_list(ymca *socket_liste, int fd, void *data);
void *get_data_from_socket_list_with_fd(ymca socket_liste, int fd);

/* remove a fd from list, unallow memory, and return next structure */
ymca remove_fd_from_socket_list(ymca *socket_liste, int fd, void **data);

void *get_data_and_remove_fd_from_socket_list(ymca *socket_liste, int fd);
int get_next_active_fd(ymca socket_liste, struct timeval *timeout);

int vider_struct_ymca_t(ymca elt);

#endif
